/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * Model199
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Model199 {
  @SerializedName("country_taxes")
  private CountryTaxes countryTaxes = null;

  @SerializedName("total_taxes")
  private BigDecimal totalTaxes = null;

  @SerializedName("total_discount")
  private BigDecimal totalDiscount = null;

  @SerializedName("premium_after_discount_excl_tax")
  private BigDecimal premiumAfterDiscountExclTax = null;

  @SerializedName("price_before_discount_incl_tax")
  private BigDecimal priceBeforeDiscountInclTax = null;

  @SerializedName("price_after_discount_incl_tax")
  private BigDecimal priceAfterDiscountInclTax = null;

  @SerializedName("guarantees_class_prices")
  private Model198 guaranteesClassPrices = null;

  public Model199 countryTaxes(CountryTaxes countryTaxes) {
    this.countryTaxes = countryTaxes;
    return this;
  }

   /**
   * Get countryTaxes
   * @return countryTaxes
  **/
  @ApiModelProperty(value = "")
  public CountryTaxes getCountryTaxes() {
    return countryTaxes;
  }

  public void setCountryTaxes(CountryTaxes countryTaxes) {
    this.countryTaxes = countryTaxes;
  }

  public Model199 totalTaxes(BigDecimal totalTaxes) {
    this.totalTaxes = totalTaxes;
    return this;
  }

   /**
   * Total amount of taxes, numeric with 2 decimals.
   * @return totalTaxes
  **/
  @ApiModelProperty(example = "50.02", value = "Total amount of taxes, numeric with 2 decimals.")
  public BigDecimal getTotalTaxes() {
    return totalTaxes;
  }

  public void setTotalTaxes(BigDecimal totalTaxes) {
    this.totalTaxes = totalTaxes;
  }

  public Model199 totalDiscount(BigDecimal totalDiscount) {
    this.totalDiscount = totalDiscount;
    return this;
  }

   /**
   * Total amount of discount, numeric with 2 decimals.
   * @return totalDiscount
  **/
  @ApiModelProperty(example = "10.0", value = "Total amount of discount, numeric with 2 decimals.")
  public BigDecimal getTotalDiscount() {
    return totalDiscount;
  }

  public void setTotalDiscount(BigDecimal totalDiscount) {
    this.totalDiscount = totalDiscount;
  }

  public Model199 premiumAfterDiscountExclTax(BigDecimal premiumAfterDiscountExclTax) {
    this.premiumAfterDiscountExclTax = premiumAfterDiscountExclTax;
    return this;
  }

   /**
   * Premium discounted excluding taxes, numeric with 2 decimals.
   * @return premiumAfterDiscountExclTax
  **/
  @ApiModelProperty(example = "240.0", value = "Premium discounted excluding taxes, numeric with 2 decimals.")
  public BigDecimal getPremiumAfterDiscountExclTax() {
    return premiumAfterDiscountExclTax;
  }

  public void setPremiumAfterDiscountExclTax(BigDecimal premiumAfterDiscountExclTax) {
    this.premiumAfterDiscountExclTax = premiumAfterDiscountExclTax;
  }

  public Model199 priceBeforeDiscountInclTax(BigDecimal priceBeforeDiscountInclTax) {
    this.priceBeforeDiscountInclTax = priceBeforeDiscountInclTax;
    return this;
  }

   /**
   * Price not discounted including taxes, numeric with 2 decimals.
   * @return priceBeforeDiscountInclTax
  **/
  @ApiModelProperty(example = "340.45", value = "Price not discounted including taxes, numeric with 2 decimals.")
  public BigDecimal getPriceBeforeDiscountInclTax() {
    return priceBeforeDiscountInclTax;
  }

  public void setPriceBeforeDiscountInclTax(BigDecimal priceBeforeDiscountInclTax) {
    this.priceBeforeDiscountInclTax = priceBeforeDiscountInclTax;
  }

  public Model199 priceAfterDiscountInclTax(BigDecimal priceAfterDiscountInclTax) {
    this.priceAfterDiscountInclTax = priceAfterDiscountInclTax;
    return this;
  }

   /**
   * Price discounted including taxes (Final price), numeric with 2 decimals.
   * @return priceAfterDiscountInclTax
  **/
  @ApiModelProperty(example = "330.45", required = true, value = "Price discounted including taxes (Final price), numeric with 2 decimals.")
  public BigDecimal getPriceAfterDiscountInclTax() {
    return priceAfterDiscountInclTax;
  }

  public void setPriceAfterDiscountInclTax(BigDecimal priceAfterDiscountInclTax) {
    this.priceAfterDiscountInclTax = priceAfterDiscountInclTax;
  }

  public Model199 guaranteesClassPrices(Model198 guaranteesClassPrices) {
    this.guaranteesClassPrices = guaranteesClassPrices;
    return this;
  }

   /**
   * Get guaranteesClassPrices
   * @return guaranteesClassPrices
  **/
  @ApiModelProperty(value = "")
  public Model198 getGuaranteesClassPrices() {
    return guaranteesClassPrices;
  }

  public void setGuaranteesClassPrices(Model198 guaranteesClassPrices) {
    this.guaranteesClassPrices = guaranteesClassPrices;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Model199 model199 = (Model199) o;
    return Objects.equals(this.countryTaxes, model199.countryTaxes) &&
        Objects.equals(this.totalTaxes, model199.totalTaxes) &&
        Objects.equals(this.totalDiscount, model199.totalDiscount) &&
        Objects.equals(this.premiumAfterDiscountExclTax, model199.premiumAfterDiscountExclTax) &&
        Objects.equals(this.priceBeforeDiscountInclTax, model199.priceBeforeDiscountInclTax) &&
        Objects.equals(this.priceAfterDiscountInclTax, model199.priceAfterDiscountInclTax) &&
        Objects.equals(this.guaranteesClassPrices, model199.guaranteesClassPrices);
  }

  @Override
  public int hashCode() {
    return Objects.hash(countryTaxes, totalTaxes, totalDiscount, premiumAfterDiscountExclTax, priceBeforeDiscountInclTax, priceAfterDiscountInclTax, guaranteesClassPrices);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Model199 {\n");
    
    sb.append("    countryTaxes: ").append(toIndentedString(countryTaxes)).append("\n");
    sb.append("    totalTaxes: ").append(toIndentedString(totalTaxes)).append("\n");
    sb.append("    totalDiscount: ").append(toIndentedString(totalDiscount)).append("\n");
    sb.append("    premiumAfterDiscountExclTax: ").append(toIndentedString(premiumAfterDiscountExclTax)).append("\n");
    sb.append("    priceBeforeDiscountInclTax: ").append(toIndentedString(priceBeforeDiscountInclTax)).append("\n");
    sb.append("    priceAfterDiscountInclTax: ").append(toIndentedString(priceAfterDiscountInclTax)).append("\n");
    sb.append("    guaranteesClassPrices: ").append(toIndentedString(guaranteesClassPrices)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

